Index: lib/libc/gen/getmntinfo.c
===================================================================
RCS file: /home/ncvs/src/lib/libc/gen/getmntinfo.c,v
retrieving revision 1.2
diff -u -r1.2 getmntinfo.c
--- lib/libc/gen/getmntinfo.c	2001/05/01 09:30:02	1.2
+++ lib/libc/gen/getmntinfo.c	2001/06/03 13:56:21
@@ -40,6 +40,7 @@
 #include <sys/param.h>
 #include <sys/lock.h>
 #include <sys/mutex.h>
+#include <sys/mac.h>
 #include <sys/ucred.h>
 #include <sys/mount.h>
 #include <stdlib.h>
cvs diff: Diffing lib/libc/gmon
cvs diff: Diffing lib/libc/i386
cvs diff: Diffing lib/libc/i386/gen
cvs diff: Diffing lib/libc/i386/net
cvs diff: Diffing lib/libc/i386/stdlib
cvs diff: Diffing lib/libc/i386/string
cvs diff: Diffing lib/libc/i386/sys
cvs diff: Diffing lib/libc/ia64
cvs diff: Diffing lib/libc/ia64/gen
cvs diff: Diffing lib/libc/ia64/net
cvs diff: Diffing lib/libc/ia64/stdlib
cvs diff: Diffing lib/libc/ia64/string
cvs diff: Diffing lib/libc/ia64/sys
cvs diff: Diffing lib/libc/include
cvs diff: Diffing lib/libc/locale
cvs diff: Diffing lib/libc/mips
cvs diff: Diffing lib/libc/mips/gen
cvs diff: Diffing lib/libc/mips/net
cvs diff: Diffing lib/libc/mips/stdlib
cvs diff: Diffing lib/libc/mips/string
cvs diff: Diffing lib/libc/mips/sys
cvs diff: Diffing lib/libc/mipseb
cvs diff: Diffing lib/libc/mipseb/gen
cvs diff: Diffing lib/libc/mipseb/net
cvs diff: Diffing lib/libc/mipseb/stdlib
cvs diff: Diffing lib/libc/mipseb/string
cvs diff: Diffing lib/libc/mipseb/sys
cvs diff: Diffing lib/libc/mipsel
cvs diff: Diffing lib/libc/mipsel/gen
cvs diff: Diffing lib/libc/mipsel/net
cvs diff: Diffing lib/libc/mipsel/stdlib
cvs diff: Diffing lib/libc/mipsel/string
cvs diff: Diffing lib/libc/mipsel/sys
cvs diff: Diffing lib/libc/net
cvs diff: Diffing lib/libc/nls
cvs diff: Diffing lib/libc/posix1e
Index: lib/libc/posix1e/Makefile.inc
===================================================================
RCS file: /home/ncvs/src/lib/libc/posix1e/Makefile.inc,v
retrieving revision 1.6
diff -u -r1.6 Makefile.inc
--- lib/libc/posix1e/Makefile.inc	2001/09/01 00:00:50	1.6
+++ lib/libc/posix1e/Makefile.inc	2001/09/09 02:17:41
@@ -32,7 +32,12 @@
 	cap_set_file.c			\
 	cap_set_flag.c			\
 	cap_set_proc.c			\
-	cap_text.c
+	cap_text.c			\
+	mac_constant.c			\
+	mac_free.c			\
+	mac_get.c			\
+	mac_set.c			\
+	mac_text.c
 
 .if ${LIB} == "c"
 
Index: lib/libc/posix1e/mac_constant.c
===================================================================
RCS file: mac_constant.c
diff -N mac_constant.c
--- /dev/null	Fri Sep 21 08:55:01 2001
+++ mac_constant.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,21 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+/*
+ * The following label defines "system high", used by the TrustedBSD
+ * userland Trusted Code Base (TCB).  It is assigned during the install
+ * process to TCB files, and used by privileged processes when setting
+ * rights on files that are part of the TCB (/etc/passwd and so on).
+ * Changing this label has serious consequences both in terms of
+ * propagation (recompile everything, make sure the kernel default
+ * label matches, etc), as well as security (changing this may break
+ * assumptions throughout the system).  Don't change it unless you
+ * know what you're doing.  Seriously.
+ */
+
+const struct mac mac_userland_system_high_label = {
+	{MAC_BIBA_TYPE_HIGH, 0},
+	{MAC_MLS_TYPE_LOW, 0},
+	{MAC_PARTITION_TYPE_NONE, 0}
+};
+
Index: lib/libc/posix1e/mac_free.c
===================================================================
RCS file: mac_free.c
diff -N mac_free.c
--- /dev/null	Fri Sep 21 08:55:01 2001
+++ mac_free.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,12 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <stdlib.h>
+
+int
+mac_free(void *buf_p)
+{
+
+	free(buf_p);
+	return (0);
+}
Index: lib/libc/posix1e/mac_get.c
===================================================================
RCS file: mac_get.c
diff -N mac_get.c
--- /dev/null	Fri Sep 21 08:55:01 2001
+++ mac_get.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,68 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <errno.h>
+#include <stdlib.h>
+
+mac_t
+mac_get_file(const char *path_p)
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_file(path_p, label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
+
+mac_t
+mac_get_fd(int fd)
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_fd(fd, label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
+
+mac_t
+mac_get_proc()
+{
+	struct mac *label;
+	int error;
+
+	label = (mac_t) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+
+	error = __mac_get_proc(label);
+	if (error) {
+		mac_free(label);
+		return (NULL);
+	}
+
+	return (label);
+}
Index: lib/libc/posix1e/mac_set.c
===================================================================
RCS file: mac_set.c
diff -N mac_set.c
--- /dev/null	Fri Sep 21 08:55:01 2001
+++ mac_set.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,23 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+int
+mac_set_file(const char *path_p, mac_t label)
+{
+
+	return (__mac_set_file(path_p, label));
+}
+
+int
+mac_set_fd(int fd, mac_t label)
+{
+
+	return (__mac_set_fd(fd, label));
+}
+
+int
+mac_set_proc(mac_t label)
+{
+
+	return (__mac_set_proc(label));
+}
Index: lib/libc/posix1e/mac_text.c
===================================================================
RCS file: mac_text.c
diff -N mac_text.c
--- /dev/null	Fri Sep 21 08:55:01 2001
+++ mac_text.c	Sun Jun  3 10:07:26 2001
@@ -0,0 +1,391 @@
+#include <sys/types.h>
+#include <sys/mac.h>
+
+#include <errno.h>
+#include <stdio.h>
+#include <string.h>
+
+/*
+ * POSIX.1e does not define a text format for MAC label string conversions.
+ * We use the following format:
+ * "policy/qualifier,..."
+ * Where:
+ *  policy can be one of "biba", "mls", "partition
+ *  type for "biba" can be "high", "low", "equal", or a numeric grade
+ *  type for "mls" can be "high", "low", "equal", of a numeric level
+ *  type for "partition" can be "none", "all", or a numeric partition
+ * All policies must be present, but may be in any order.
+ *
+ * Sample labels:
+ *   biba/high,mls/low,partition/none
+ *   biba/low,mls/low,partition/none
+ *   biba/low,mls/low,partition/3
+ *   biba/low,mls/3,partition/none
+ */
+
+/*
+ * XXX: Parsing code below assumes these next two constants will be
+ * character strings containing a single character.
+ */
+#define	STRING_SEP	","
+#define	STRING_ASSIGN	"/"
+
+#define	STRING_BIBA	"biba"
+#define	STRING_MLS	"mls"
+#define	STRING_PARTITION	"partition"
+static char *STRING_UNKNOWN = "unknown";
+
+static char *STRING_BIBA_HIGH = "high";
+static char *STRING_BIBA_LOW = "low";
+static char *STRING_BIBA_EQUAL = "equal";
+
+static char *STRING_MLS_HIGH = "high";
+static char *STRING_MLS_LOW = "low";
+static char *STRING_MLS_EQUAL = "equal";
+
+static char *STRING_PARTITION_NONE = "none";
+static char *STRING_PARTITION_ALL = "all";
+
+static int
+biba_string_to_label(char *string, struct mac_biba *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_BIBA) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mb_grade = 0;
+	if (strcmp(token, STRING_BIBA_HIGH) == 0)
+		label->mb_type = MAC_BIBA_TYPE_HIGH;
+	else if (strcmp(token, STRING_BIBA_LOW) == 0)
+		label->mb_type = MAC_BIBA_TYPE_LOW;
+	else if (strcmp(token, STRING_BIBA_EQUAL) == 0)
+		label->mb_type = MAC_BIBA_TYPE_EQUAL;
+	else {
+		/* Should be a numeric grade. */
+		/* XXX: Check range for strtoul. */
+		label->mb_type = MAC_BIBA_TYPE_GRADE;
+		label->mb_grade = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+biba_label_to_string(struct mac_biba label)
+{
+	char *buf;
+
+	switch (label.mb_type) {
+	case MAC_BIBA_TYPE_GRADE:
+		asprintf(&buf, "%s%s%hu", STRING_BIBA, STRING_ASSIGN,
+		    label.mb_grade);
+		break;
+	case MAC_BIBA_TYPE_LOW:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_LOW);
+		break;
+	case MAC_BIBA_TYPE_HIGH:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_HIGH);
+		break;
+	case MAC_BIBA_TYPE_EQUAL:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_BIBA_EQUAL);
+		break;
+	default:
+		asprintf(&buf, "%s%s%s", STRING_BIBA, STRING_ASSIGN,
+		    STRING_UNKNOWN);
+	}
+
+	return (buf);
+}
+
+static int
+mls_string_to_label(char *string, struct mac_mls *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_MLS) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mm_level = 0;
+	if (strcmp(token, STRING_MLS_HIGH) == 0)
+		label->mm_type = MAC_MLS_TYPE_HIGH;
+	else if (strcmp(token, STRING_MLS_LOW) == 0)
+		label->mm_type = MAC_MLS_TYPE_LOW;
+	else if (strcmp(token, STRING_MLS_EQUAL) == 0)
+		label->mm_type = MAC_MLS_TYPE_EQUAL;
+	else {
+		/* Should be a numeric level. */
+		/* XXX: Check range for strtoul. */
+		label->mm_type = MAC_MLS_TYPE_LEVEL;
+		label->mm_level = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+mls_label_to_string(struct mac_mls label)
+{
+	char *buf;
+
+	switch (label.mm_type) {
+	case MAC_MLS_TYPE_LEVEL:
+		asprintf(&buf, "%s%s%hu", STRING_MLS, STRING_ASSIGN,
+		    label.mm_level);
+		break;
+	case MAC_MLS_TYPE_LOW:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_LOW);
+		break;
+	case MAC_MLS_TYPE_HIGH:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_HIGH);
+		break;
+	case MAC_MLS_TYPE_EQUAL:
+		asprintf(&buf, "%s%s%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_MLS_EQUAL);
+		break;
+	default:
+		asprintf(&buf, "%s:%s", STRING_MLS, STRING_ASSIGN,
+		    STRING_UNKNOWN);
+	}
+
+	return (buf);
+}
+
+static int
+partition_string_to_label(char *string, struct mac_partition *label)
+{
+	char *local_string, *token, *next_token, *tmp;
+	int error = 0;
+
+	local_string = strdup(string);
+	if (local_string == NULL)
+		return (ENOMEM);
+
+	next_token = local_string;
+	token = strsep(&next_token, STRING_ASSIGN);
+
+	if (strcmp(token, STRING_PARTITION) != 0) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	token = strsep(&next_token, STRING_ASSIGN);
+	if (token == NULL) {
+		error = EINVAL;
+		goto exit1;
+	}
+
+	label->mp_partition = 0;
+	if (strcmp(token, STRING_PARTITION_NONE) == 0)
+		label->mp_type = MAC_PARTITION_TYPE_NONE;
+	else if (strcmp(token, STRING_PARTITION_ALL) == 0)
+		label->mp_type = MAC_PARTITION_TYPE_ALL;
+	else {
+		/* Should be a numeric partition identifier. */
+		/* XXX: Should check range for strtoul. */
+		label->mp_type = MAC_PARTITION_TYPE_PARTITION;
+		label->mp_partition = strtoul(token, &tmp, 10);
+		if (*tmp != '\0')
+			error = EINVAL;
+	}
+
+	if (next_token != NULL)
+		error = EINVAL;
+
+exit1:
+	free(local_string);
+	return (error);
+}
+
+static char *
+partition_label_to_string(struct mac_partition label)
+{
+	char *buf;
+
+	switch (label.mp_type) {
+	case MAC_PARTITION_TYPE_PARTITION:
+		asprintf(&buf, "%s%s%hu", STRING_PARTITION, STRING_ASSIGN,
+		    label.mp_partition);
+		break;
+	case MAC_PARTITION_TYPE_ALL:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_PARTITION_ALL);
+		break;
+	case MAC_PARTITION_TYPE_NONE:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_PARTITION_NONE);
+		break;
+	default:
+		asprintf(&buf, "%s%s%s", STRING_PARTITION, STRING_ASSIGN,
+		    STRING_UNKNOWN);	
+	}
+
+	return (buf);
+}
+
+char *
+mac_to_text(struct mac *mac_p, size_t *len_p)
+{
+	char *biba, *mls, *partition;
+	char *buf;
+	int len;
+
+	biba = biba_label_to_string(mac_p->m_biba);
+	if (biba == NULL) {
+		errno = ENOMEM;
+		return (NULL);
+	}
+	mls = mls_label_to_string(mac_p->m_mls);
+	if (mls == NULL) {
+		errno = ENOMEM;
+		free(biba);
+		return (NULL);
+	}
+	partition = partition_label_to_string(mac_p->m_partition);
+	if (partition == NULL) {
+		errno = ENOMEM;
+		free(biba);
+		free(mls);
+		return (NULL);
+	}
+
+	len = asprintf(&buf, "%s%s%s%s%s", biba, STRING_SEP, mls, STRING_SEP,
+	    partition);
+
+	free(biba);
+	free(mls);
+	free(partition);
+
+	if (len != -1 && len_p != NULL)
+		*len_p = len;
+
+	return (buf);
+}
+
+struct mac *
+mac_from_text(const char *text_p)
+{
+	struct mac *label;
+	char *local_string, *next_token, *token, *tmp;
+	int biba_seen = 0, mls_seen = 0, partition_seen = 0;
+	int error;
+
+	/*
+	 * Parse into three assignments, determine which assignments
+	 * they are and recurse appropriately, and reject if there are
+	 * not the right assignments (or duplicates).
+	 */
+
+	label = (struct mac *) malloc(sizeof(*label));
+	if (label == NULL) {
+		errno = ENOMEM;
+		goto exit1;
+	}
+
+	local_string = strdup(text_p);
+	if (local_string == NULL) {
+		errno = ENOMEM;
+		goto exit2;
+	}
+
+	next_token = local_string;
+	while ((token = strsep(&next_token, STRING_SEP)) != NULL) {
+
+		if (strncmp(token, STRING_BIBA STRING_ASSIGN, strlen(
+		    STRING_BIBA STRING_ASSIGN)) == 0) {
+			error = biba_string_to_label(token, &label->m_biba);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			biba_seen++;
+		} else if (strncmp(token, STRING_MLS STRING_ASSIGN, strlen(
+		    STRING_MLS STRING_ASSIGN)) == 0) {
+			error = mls_string_to_label(token, &label->m_mls);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			mls_seen++;
+		} else if (strncmp(token, STRING_PARTITION STRING_ASSIGN,
+		    strlen(STRING_PARTITION STRING_ASSIGN)) == 0) {
+			error = partition_string_to_label(token,
+			    &label->m_partition);
+			if (error) {
+				errno = error;
+				goto exit2;
+			}
+			partition_seen++;
+		} else {
+			/* Unrecognized label type name. */
+			errno = EINVAL;
+			goto exit2;
+		}
+	}
+
+	if (biba_seen != 1 || mls_seen != 1 || partition_seen != 1) {
+		errno = EINVAL;
+		goto exit2;
+	}
+
+	/* Success. */
+	goto exit1;
+
+exit2:
+	free(label);
+	label = NULL;
+exit1:
+	free(local_string);
+	return (label);
+}
cvs diff: Diffing lib/libc/quad
cvs diff: Diffing lib/libc/quad/TESTS
cvs diff: Diffing lib/libc/regex
cvs diff: Diffing lib/libc/regex/grot
cvs diff: Diffing lib/libc/rpc
cvs diff: Diffing lib/libc/rpc/PSD.doc
cvs diff: Diffing lib/libc/stdio
cvs diff: Diffing lib/libc/stdlib
cvs diff: Diffing lib/libc/stdtime
cvs diff: Diffing lib/libc/string
cvs diff: Diffing lib/libc/sys
cvs diff: Diffing lib/libc/xdr
cvs diff: Diffing lib/libc/yp
cvs diff: Diffing lib/libc_r
cvs diff: Diffing lib/libc_r/arch
cvs diff: Diffing lib/libc_r/arch/alpha
cvs diff: Diffing lib/libc_r/arch/i386
cvs diff: Diffing lib/libc_r/man
cvs diff: Diffing lib/libc_r/sys
cvs diff: Diffing lib/libc_r/test
cvs diff: Diffing lib/libc_r/uthread
cvs diff: Diffing lib/libcalendar
cvs diff: Diffing lib/libcam
cvs diff: Diffing lib/libcom_err
Index: lib/libcom_err/Makefile
===================================================================
RCS file: /home/ncvs/src/lib/libcom_err/Makefile,v
retrieving revision 1.12
diff -u -r1.12 Makefile
--- lib/libcom_err/Makefile	2001/03/27 17:26:58	1.12
+++ lib/libcom_err/Makefile	2001/06/11 23:23:00
@@ -3,7 +3,7 @@
 LIB=	com_err
 SRCS=	com_err.c error.c
 INCS=	${COM_ERRDIR}/com_err.h ${COM_ERRDIR}/com_right.h
-MAN=	com_err.3
+#MAN=	com_err.3
 COM_ERRDIR=	${.CURDIR}/../../contrib/com_err
 CFLAGS+=	-I${COM_ERRDIR}
 
cvs diff: Diffing lib/libcom_err/doc
cvs diff: Diffing lib/libcompat
cvs diff: Diffing lib/libcompat/4.1
cvs diff: Diffing lib/libcompat/4.3
cvs diff: Diffing lib/libcompat/4.4
cvs diff: Diffing lib/libcompat/regexp
cvs diff: Diffing lib/libcrypt
cvs diff: Diffing lib/libdevinfo
cvs diff: Diffing lib/libdevstat
cvs diff: Diffing lib/libdisk
cvs diff: Diffing lib/libedit
cvs diff: Diffing lib/libedit/TEST
cvs diff: Diffing lib/libfetch
cvs diff: Diffing lib/libform
cvs diff: Diffing lib/libftpio
cvs diff: Diffing lib/libgnumalloc
cvs diff: Diffing lib/libio
cvs diff: Diffing lib/libipsec
cvs diff: Diffing lib/libipx
cvs diff: Diffing lib/libisc
cvs diff: Diffing lib/libkvm
cvs diff: Diffing lib/libm
cvs diff: Diffing lib/libm/common
cvs diff: Diffing lib/libm/common_source
cvs diff: Diffing lib/libm/ieee
cvs diff: Diffing lib/libmd
cvs diff: Diffing lib/libmd/i386
cvs diff: Diffing lib/libmenu
cvs diff: Diffing lib/libmp
cvs diff: Diffing lib/libncp
cvs diff: Diffing lib/libncurses
cvs diff: Diffing lib/libnetgraph
cvs diff: Diffing lib/libopie
cvs diff: Diffing lib/libpam
cvs diff: Diffing lib/libpam/libpam
cvs diff: Diffing lib/libpam/libpam/security
cvs diff: Diffing lib/libpam/modules
cvs diff: Diffing lib/libpam/modules/pam_deny
cvs diff: Diffing lib/libpam/modules/pam_ftp
cvs diff: Diffing lib/libpam/modules/pam_kerberosIV
cvs diff: Diffing lib/libpam/modules/pam_krb5
cvs diff: Diffing lib/libpam/modules/pam_nologin
cvs diff: Diffing lib/libpam/modules/pam_opie
cvs diff: Diffing lib/libpam/modules/pam_permit
cvs diff: Diffing lib/libpam/modules/pam_radius
cvs diff: Diffing lib/libpam/modules/pam_rootok
cvs diff: Diffing lib/libpam/modules/pam_securetty
cvs diff: Diffing lib/libpam/modules/pam_ssh
cvs diff: Diffing lib/libpam/modules/pam_tacplus
cvs diff: Diffing lib/libpam/modules/pam_unix
cvs diff: Diffing lib/libpam/modules/pam_wheel
cvs diff: Diffing lib/libpanel
cvs diff: Diffing lib/libpcap
cvs diff: Diffing lib/libradius
cvs diff: Diffing lib/libresolv
cvs diff: Diffing lib/librpcsvc
cvs diff: Diffing lib/libsbuf
cvs diff: Diffing lib/libsmdb
cvs diff: Diffing lib/libsmutil
cvs diff: Diffing lib/libstand
cvs diff: Diffing lib/libstand/alpha
cvs diff: Diffing lib/libstand/i386
cvs diff: Diffing lib/libstand/powerpc
cvs diff: Diffing lib/libtacplus
cvs diff: Diffing lib/libtelnet
cvs diff: Diffing lib/libusb
cvs diff: Diffing lib/libutil
Index: lib/libutil/login_cap.h
===================================================================
RCS file: /home/ncvs/src/lib/libutil/login_cap.h,v
retrieving revision 1.4
diff -u -r1.4 login_cap.h
--- lib/libutil/login_cap.h	2000/08/22 02:15:52	1.4
+++ lib/libutil/login_cap.h	2000/11/19 22:56:25
@@ -47,7 +47,8 @@
 #define LOGIN_SETUMASK		0x0020		/* set umask, obviously */
 #define LOGIN_SETUSER		0x0040		/* set user (via setuid) */
 #define LOGIN_SETENV		0x0080		/* set user environment */
-#define	LOGIN_SETALL		0x00ff		/* set everything */
+#define	LOGIN_SETLABEL		0x0100		/* set user MAC label */
+#define	LOGIN_SETALL		0x01ff		/* set everything */
 
 #define BI_AUTH		"authorize"		/* accepted authentication */
 #define BI_REJECT	"reject"		/* rejected authentication */
Index: lib/libutil/login_class.c
===================================================================
RCS file: /home/ncvs/src/lib/libutil/login_class.c,v
retrieving revision 1.15
diff -u -r1.15 login_class.c
--- lib/libutil/login_class.c	2000/07/14 13:56:07	1.15
+++ lib/libutil/login_class.c	2000/12/18 05:08:37
@@ -39,6 +39,7 @@
 #include <login_cap.h>
 #include <paths.h>
 #include <sys/rtprio.h>
+#include <sys/mac.h>
 
 
 static struct login_res {
@@ -316,6 +317,7 @@
 #ifndef __NETBSD_SYSCALLS
     struct rtprio rtp;
 #endif
+    int error;
 
     if (lc == NULL) {
 	if (pwd != NULL && (lc = login_getpwclass(pwd)) != NULL)
@@ -370,6 +372,44 @@
 		   (u_long)pwd->pw_gid);
 	    login_close(llc);
 	    return -1;
+	}
+    }
+
+    /* Setup the user's MAC label. */
+    if (flags & LOGIN_SETLABEL) {
+	char *label_string;
+	mac_t label;
+
+	/*
+	 * XXX: In the following code, there are a number of "fail open"
+	 * cases in which the process label will not be set.  The following
+	 * cases need to be addressed better:
+	 * - The login.conf file does not contain a label for the user.
+	 *   but the kernel supports labeling (how to test this case?)
+	 * - The login.conf file contains a syntactically semantically
+	 *   invalid label.
+	 * - The kernel does not have support for labels compiled in, but
+	 *   a label is defined.
+	 */
+	label_string = login_getcapstr(lc, "label", NULL, NULL);
+	if (label_string == NULL) {
+	    /* Leave label as is, warning, dangerous */
+	} else {
+	    label = mac_from_text(label_string);
+	    if (label == NULL) {
+		syslog(LOG_ERR, "mac_from_text(%s): %m",
+		    label_string);
+		return -1;
+	    }
+	    error = mac_set_proc(label);
+	    mac_free(label);
+	    if (error != 0 && errno == ENOSYS) {
+		syslog(LOG_WARNING, "mac_set_proc(%s): warning: %m",
+		    label_string);
+	    } else if (error != 0) {
+		syslog(LOG_ERR, "mac_set_proc(%s): error: %m", label_string);
+		return -1;
+	    }
 	}
     }
 
cvs diff: Diffing lib/libvgl
cvs diff: Diffing lib/libwrap
cvs diff: Diffing lib/libxpg4
cvs diff: Diffing lib/liby
cvs diff: Diffing lib/libz
cvs diff: Diffing lib/msun
cvs diff: Diffing lib/msun/alpha
cvs diff: Diffing lib/msun/i387
cvs diff: Diffing lib/msun/man
cvs diff: Diffing lib/msun/src
cvs diff: Diffing libexec
cvs diff: Diffing libexec/atrun
cvs diff: Diffing libexec/bootpd
cvs diff: Diffing libexec/bootpd/bootpgw
cvs diff: Diffing libexec/bootpd/tools
cvs diff: Diffing libexec/bootpd/tools/bootpef
cvs diff: Diffing libexec/bootpd/tools/bootptest
cvs diff: Diffing libexec/comsat
cvs diff: Diffing libexec/fingerd
cvs diff: Diffing libexec/ftpd
Index: libexec/ftpd/ftpd.c
===================================================================
RCS file: /home/ncvs/src/libexec/ftpd/ftpd.c,v
retrieving revision 1.83
diff -u -r1.83 ftpd.c
--- libexec/ftpd/ftpd.c	2001/09/10 18:46:07	1.83
+++ libexec/ftpd/ftpd.c	2001/09/19 02:25:04
@@ -1055,7 +1055,8 @@
 	pw = NULL;
 #ifdef	LOGIN_CAP
 	setusercontext(NULL, getpwuid(0), (uid_t)0,
-		       LOGIN_SETPRIORITY|LOGIN_SETRESOURCES|LOGIN_SETUMASK);
+		       LOGIN_SETPRIORITY|LOGIN_SETRESOURCES|LOGIN_SETUMASK|
+		       LOGIN_SETLABEL);
 #endif
 #ifdef USE_PAM
 	if ((e = pam_setcred(pamh, PAM_DELETE_CRED)) != PAM_SUCCESS)
@@ -1305,7 +1306,7 @@
 	}
 	setusercontext(lc, pw, (uid_t)0,
 		LOGIN_SETLOGIN|LOGIN_SETGROUP|LOGIN_SETPRIORITY|
-		LOGIN_SETRESOURCES|LOGIN_SETUMASK);
+		LOGIN_SETRESOURCES|LOGIN_SETUMASK|LOGIN_SETLABEL);
 #else
 	setlogin(pw->pw_name);
 	(void) initgroups(pw->pw_name, pw->pw_gid);
cvs diff: Diffing libexec/getNAME
cvs diff: Diffing libexec/getty
cvs diff: Diffing libexec/mail.local
cvs diff: Diffing libexec/makekey
cvs diff: Diffing libexec/mknetid
cvs diff: Diffing libexec/named-xfer
cvs diff: Diffing libexec/pppoed
cvs diff: Diffing libexec/rbootd
cvs diff: Diffing libexec/revnetgroup
cvs diff: Diffing libexec/rexecd
cvs diff: Diffing libexec/rlogind
cvs diff: Diffing libexec/rpc.rquotad
cvs diff: Diffing libexec/rpc.rstatd
cvs diff: Diffing libexec/rpc.rusersd
cvs diff: Diffing libexec/rpc.rwalld
cvs diff: Diffing libexec/rpc.sprayd
cvs diff: Diffing libexec/rshd
cvs diff: Diffing libexec/rtld-aout
cvs diff: Diffing libexec/rtld-aout/i386
cvs diff: Diffing libexec/rtld-elf
cvs diff: Diffing libexec/rtld-elf/alpha
cvs diff: Diffing libexec/rtld-elf/i386
cvs diff: Diffing libexec/save-entropy
cvs diff: Diffing libexec/smrsh
cvs diff: Diffing libexec/talkd
cvs diff: Diffing libexec/telnetd
cvs diff: Diffing libexec/tftpd
cvs diff: Diffing libexec/uucpd
cvs diff: Diffing libexec/xtend
cvs diff: Diffing libexec/ypxfr
cvs diff: Diffing release
cvs diff: Diffing release/alpha
cvs diff: Diffing release/doc
cvs diff: Diffing release/doc/en_US.ISO8859-1
cvs diff: Diffing release/doc/en_US.ISO8859-1/errata
cvs diff: Diffing release/doc/en_US.ISO8859-1/hardware
cvs diff: Diffing release/doc/en_US.ISO8859-1/hardware/alpha
cvs diff: Diffing release/doc/en_US.ISO8859-1/hardware/common
cvs diff: Diffing release/doc/en_US.ISO8859-1/hardware/i386
cvs diff: Diffing release/doc/en_US.ISO8859-1/installation
cvs diff: Diffing release/doc/en_US.ISO8859-1/installation/alpha
cvs diff: Diffing release/doc/en_US.ISO8859-1/installation/common
cvs diff: Diffing release/doc/en_US.ISO8859-1/installation/i386
cvs diff: Diffing release/doc/en_US.ISO8859-1/readme
cvs diff: Diffing release/doc/en_US.ISO8859-1/relnotes
cvs diff: Diffing release/doc/en_US.ISO8859-1/relnotes/alpha
cvs diff: Diffing release/doc/en_US.ISO8859-1/relnotes/common
cvs diff: Diffing release/doc/en_US.ISO8859-1/relnotes/i386
cvs diff: Diffing release/doc/en_US.ISO8859-1/share
cvs diff: Diffing release/doc/en_US.ISO8859-1/share/sgml
cvs diff: Diffing release/doc/ja_JP.eucJP
cvs diff: Diffing release/doc/ja_JP.eucJP/errata
cvs diff: Diffing release/doc/ja_JP.eucJP/relnotes
cvs diff: Diffing release/doc/ja_JP.eucJP/relnotes/alpha
cvs diff: Diffing release/doc/ja_JP.eucJP/relnotes/common
cvs diff: Diffing release/doc/ja_JP.eucJP/relnotes/i386
cvs diff: Diffing release/doc/ja_JP.eucJP/share
cvs diff: Diffing release/doc/ja_JP.eucJP/share/sgml
cvs diff: Diffing release/doc/share
cvs diff: Diffing release/doc/share/examples
cvs diff: Diffing release/doc/share/mk
cvs diff: Diffing release/doc/share/sgml
cvs diff: Diffing release/i386
cvs diff: Diffing release/pc98
cvs diff: Diffing release/picobsd
cvs diff: Diffing release/picobsd/bridge
cvs diff: Diffing release/picobsd/build
cvs diff: Diffing release/picobsd/custom
cvs diff: Diffing release/picobsd/custom/crunch1
cvs diff: Diffing release/picobsd/custom/crunch2
cvs diff: Diffing release/picobsd/custom/floppy.etc
cvs diff: Diffing release/picobsd/custom/floppy.etc/ppp
cvs diff: Diffing release/picobsd/custom/floppy.tree
cvs diff: Diffing release/picobsd/custom/floppy.tree/boot
cvs diff: Diffing release/picobsd/custom/lang
cvs diff: Diffing release/picobsd/custom/mfs
cvs diff: Diffing release/picobsd/custom/mfs/etc
cvs diff: Diffing release/picobsd/dial
cvs diff: Diffing release/picobsd/dial/floppy.tree
cvs diff: Diffing release/picobsd/dial/floppy.tree/etc
cvs diff: Diffing release/picobsd/dial/floppy.tree/etc/ppp
cvs diff: Diffing release/picobsd/dial/lang
cvs diff: Diffing release/picobsd/doc
cvs diff: Diffing release/picobsd/doc/src
cvs diff: Diffing release/picobsd/floppy.tree
cvs diff: Diffing release/picobsd/floppy.tree/etc
cvs diff: Diffing release/picobsd/floppy.tree/etc/ppp
cvs diff: Diffing release/picobsd/help
cvs diff: Diffing release/picobsd/install
cvs diff: Diffing release/picobsd/install/crunch1
cvs diff: Diffing release/picobsd/install/floppy.tree
cvs diff: Diffing release/picobsd/install/floppy.tree/etc
cvs diff: Diffing release/picobsd/install/lang
cvs diff: Diffing release/picobsd/isp
cvs diff: Diffing release/picobsd/isp/lang
cvs diff: Diffing release/picobsd/mfs_tree
cvs diff: Diffing release/picobsd/mfs_tree/etc
cvs diff: Diffing release/picobsd/mfs_tree/stand
cvs diff: Diffing release/picobsd/net
cvs diff: Diffing release/picobsd/net/floppy.tree
cvs diff: Diffing release/picobsd/net/floppy.tree/etc
cvs diff: Diffing release/picobsd/net/floppy.tree/etc/ppp
cvs diff: Diffing release/picobsd/net/lang
cvs diff: Diffing release/picobsd/router
cvs diff: Diffing release/picobsd/router/floppy.tree
cvs diff: Diffing release/picobsd/router/floppy.tree/etc
cvs diff: Diffing release/picobsd/router/lang
cvs diff: Diffing release/picobsd/tinyware
cvs diff: Diffing release/picobsd/tinyware/aps
cvs diff: Diffing release/picobsd/tinyware/help
cvs diff: Diffing release/picobsd/tinyware/msg
cvs diff: Diffing release/picobsd/tinyware/msh
cvs diff: Diffing release/picobsd/tinyware/ns
cvs diff: Diffing release/picobsd/tinyware/oinit
cvs diff: Diffing release/picobsd/tinyware/simple_httpd
cvs diff: Diffing release/picobsd/tinyware/sps
cvs diff: Diffing release/picobsd/tinyware/view
cvs diff: Diffing release/picobsd/tinyware/vm
cvs diff: Diffing release/scripts
cvs diff: Diffing release/scripts/X11
cvs diff: Diffing release/texts
cvs diff: Diffing sbin
cvs diff: Diffing sbin/adjkerntz
cvs diff: Diffing sbin/atacontrol
cvs diff: Diffing sbin/atm
cvs diff: Diffing sbin/atm/atm
cvs diff: Diffing sbin/atm/fore_dnld
cvs diff: Diffing sbin/atm/ilmid
cvs diff: Diffing sbin/badsect
cvs diff: Diffing sbin/camcontrol
cvs diff: Diffing sbin/ccdconfig
cvs diff: Diffing sbin/clri
cvs diff: Diffing sbin/comcontrol
cvs diff: Diffing sbin/dhclient
cvs diff: Diffing sbin/disklabel
cvs diff: Diffing sbin/dmesg
cvs diff: Diffing sbin/dump
cvs diff: Diffing sbin/dumpfs
cvs diff: Diffing sbin/dumpon
cvs diff: Diffing sbin/ffsinfo
cvs diff: Diffing sbin/fsck
cvs diff: Diffing sbin/fsck_ffs
cvs diff: Diffing sbin/fsck_ffs/SMM.doc
cvs diff: Diffing sbin/fsck_ifs
cvs diff: Diffing sbin/fsck_msdosfs
cvs diff: Diffing sbin/fsdb
cvs diff: Diffing sbin/fsirand
cvs diff: Diffing sbin/growfs
cvs diff: Diffing sbin/i386
cvs diff: Diffing sbin/i386/cxconfig
cvs diff: Diffing sbin/i386/fdisk
cvs diff: Diffing sbin/i386/nextboot
cvs diff: Diffing sbin/ifconfig
